/**
 * Allow a fixed length function to be partially applied.
 * @param f Function you'd like to curry
 */
export const curry = (f) => {
    return curriedN(f.length, f, []);
};
function curriedN(arity, f, previousArgs) {
    if (arity < 2) {
        return f;
    }
    return (...args) => {
        const concatArgs = previousArgs.concat(args);
        return concatArgs.length >= arity ? f(...concatArgs) : curriedN(arity, f, concatArgs);
    };
}
//# sourceMappingURL=curry.js.map