import { Arity1 } from './types';
/**
 * Uses ES2015 Proxy to partially apply a function that takes in an options object
 * @param f :: Object a => (a -> b)
 */
export declare const curryObj: <A extends {}, B>(f: Arity1<A, B>) => CurryObj<A, B>;
export declare type CurryObj<A extends {}, B> = <C extends Partial<A>>(c: C) => C extends A ? B : CurryObj<Required<{
    [K in Exclude<keyof A, keyof C>]: A[K];
}>, B>;
//# sourceMappingURL=curryObj.d.ts.map